﻿# Connect to the webservice and increase the timeout (the default is 30 seconds)
$webservice = New-WebServiceProxy -Uri "http://127.0.0.1:7057/RETELIT_70SP10_IT/WS/RETELIT Company/Codeunit/WEBSERVICETEST" -UseDefaultCredential true
$webservice.Timeout = 7200000

# Call some functions to send simple data to NAV
$webservice.CreateCode("Some Code")
$webservice.CreateText("Some text")
$webservice.CreateDate("2014-01-12")
$webservice.CreateDate("1753-01-01") # to have NAV-Date "0D" you need to send date "1753/01/01"
$webservice.CreateTime("12:13:14.123")
$webservice.CreateDateTime("2014/01/12T12:13:14.123")
$webservice.CreateDateTime("1753-01-01T00:00:00.000") # to have NAV-DateTime "0DT" you need to send date "1753/01/01 00:00:00"


$webservice.CreateInteger(10)
$webservice.CreateInteger("11")
$webservice.CreateDecimal(1 / 3)
$webservice.CreateDecimal("123.456")
$webservice.CreateBoolean(True) # gives an error
$webservice.CreateBoolean(False) # gives an error
$webservice.CreateBoolean("Something") # is true in NAV
$webservice.CreateBoolean("True") # is true in NAV
$webservice.CreateBoolean("False") # is TRUE in NAV!!!!!!!!!!
$webservice.CreateBoolean(1) # is true
$webservice.CreateBoolean(0) # is false

# Call a function to get some simple data from NAV into a POSH variable
$var = 'x'
$webservice.GetSomeRandomValue([ref] $var)
$var

# Call a function to get some simple data from NAV and print it directly to the console
$webservice.GetSomeRandomReturnValue()

# Call a function to get some complex data from NAV into a POSH variable
cls
$var = 'x'
$webservice.GetWebServiceTestText([ref] $var)
$var

# Call a function to get some complex data from NAV as a text-return-value ()
cls
$var = 'x'
$var = $webservice.GetWebServiceTestTextReturnValue()
$var

# call the NAV webservice to send some XML-data
$xyz = @'
<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<WebServiceTest xmlns="urn:microsoft-dynamics-nav/xmlports/x60000">
  <WebServiceTest>
    <TheCode>POSH CODE1</TheCode>
    <TheText></TheText>
    <TheDate></TheDate>
    <TheTime></TheTime>
    <TheDateTime></TheDateTime>
    <TheInteger>0</TheInteger>
    <TheDecimal>0</TheDecimal>
    <TheBoolean>false</TheBoolean>
  </WebServiceTest>
  <WebServiceTest>
    <TheCode>POSH CODE2</TheCode>
    <TheText></TheText>
    <TheDate></TheDate>
    <TheTime></TheTime>
    <TheDateTime></TheDateTime>
    <TheInteger>0</TheInteger>
    <TheDecimal>0</TheDecimal>
    <TheBoolean>false</TheBoolean>
  </WebServiceTest>
</WebServiceTest>
'@
$webservice.CreateWebServiceTestText($xyz)

# call the NAV webservice to send some XML-data and NAV throws back an error
$xyz = @'
<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<WebServiceTest xmlns="urn:microsoft-dynamics-nav/xmlports/x60000">
  <WebServiceTest>
    <TheCode>ERROR</TheCode>
    <TheText></TheText>
    <TheDate></TheDate>
    <TheTime></TheTime>
    <TheDateTime></TheDateTime>
    <TheInteger>0</TheInteger>
    <TheDecimal>0</TheDecimal>
    <TheBoolean>false</TheBoolean>
  </WebServiceTest>
</WebServiceTest>
'@ 
# this XML raises an ERROR in NAV C/AL code that is thrown back to the caller (in this case this POSH-script)
#  In the XML-port I have put some code that tests if "TheCode" has "ERROR" as value and if it has, raises an error
$webservice.CreateWebServiceTestText($xyz)
